function [E] = euler(h, a, b, y0, dh, gp)
% INPUT
% h - prawa strona rownania (podana w oddzielnym m-file'u)
% [a, b] - przedzial na ktorym jest rozwiazywane rownanie
% dh - krok pochodnej
% y0 - wartosc funkcji y(t0) 

% OUTPUT 
% E - wektory T i Y (Y-przyblizone rozwiazania rownania)

M=round((b-a)/dh)
T=zeros(1,M+1);
Y=zeros(1,M+1);
T=a:dh:b;
Y(1)=y0;

for j=1:M
    Y(j+1)=Y(j)+dh*feval('h',T(j),Y(j));
end
error_glob=abs(feval('gp',b)-Y(M+1))
E=[T' Y'];