function [H] = huen(h, a, b, y0, dh, gp)
% INPUT
% h - prawa strona rownania (podana w oddzielnym m-file'u)
% [a, b] - przedzial na ktorym jest rozwiazywane rownanie
% dh - krok pochodnej
% y0 - wartosc funkcji y(t0) 

% OUTPUT 
% E - wektory T i Y (Y-przyblizone rozwiazania rownania)

M=round((b-a)/dh)
T=zeros(1,M+1);
Y=zeros(1,M+1);
T=a:dh:b;
Y(1)=y0;

for j=1:M
    k1=feval('h',T(j),Y(j));
    k2=feval('h',T(j+1),Y(j)+dh*k1);
    Y(j+1)=Y(j)+0.5*dh*(k1+k2);
end
error_glob=abs(feval('gp',b)-Y(M+1))
H=[T' Y'];