function [P, GP, Err] = pochodne(g, gp, p0, h)
% INPUT
% g - funkcja (podana w oddzielnym m-file'u)
% p0 - punkt w ktorym obliczamy pochodn g'
% h - krok pochodnej

% OUTPUT 
% P - wartosc pochodnej
% GP - wartosci funkcji g wokol punktu p0
% Err - blad pomiedzy rozwiazaniem dokladnym a numerycznym

for k=-2:2
    P(k+3)=feval('g',(p0+k*h));
end

disp('Metoda 1) y^(x)=(y(x_(i+1))-y(x_(i)))/h')
GP(1)=(P(4)-P(3))/h;
a=feval('gp',p0);
Err(1)=abs(GP(1)-a);
disp('Metoda 2) y^(x)=(y(x_(i))-y(x_(i-1)))/h')
GP(2)=(P(3)-P(2))/h;
Err(2)=abs(GP(2)-a);
disp('Metoda 3) y^(x)=(y(x_(i+1))-y(x_(i-1)))/2h')
GP(3)=(P(4)-P(2))/(2*h);
Err(3)=abs(GP(3)-a);
disp('Metoda 4) y^(x)=(-y(x_(i+2))+8*y(x_(i+1))-8*y(x_(i-1))+y(x_(i-2)))/12h')
GP(4)=(-P(5)+8*P(4)-8*P(2)+P(1))/(12*h);
Err(4)=abs(GP(4)-a);
a
P=P';
GP=GP';
Err=Err';