function X = uptrbk(A, B)
% INPUT
% A - jest N x N nieosobliwa macierz wspolczynnikow
% B - jest N x 1 macierz wyrazow wolnych

% OUTPUT
% X - jest N x 1 macierz rozwiazan

[N N] = size(A);
X=zeros(N,1);
C=zeros(1,N+1);

Aug=[A B]

% czesciowy pivoting po kolumnach p
for p=1:N-1
    [Y,j]=max(abs(Aug(p:N,p)));
    % zamiana kolumn p z j
    C=Aug(p,:);
    Aug(p,:)=Aug(j+p-1,:)
    Aug(j+p-1,:)=C;
    if Aug(p,p)==0
        'A jest macierz osobliw'
        break
    end
    
% eliminacja Gaussa dla kolumny p
    for k=p+1:N
        m=Aug(k,p)/Aug(p,p);
        Aug(k,p:N+1)=Aug(k,p:N+1)-m*Aug(p,p:N+1);
    end
end
Aug

% wsteczne podstawienie
A1=Aug(1:N,1:N);
B1=Aug(1:N,N+1);

X(N)=B1(N)/A1(N,N);
for k=N-1:-1:1
    X(k)=(B1(k)-A1(k,k+1:N)*X(k+1:N))/A1(k,k);
end
